var pingbackUrlList = new biEnumerator();
var pingbackItem = new Array(2); // it holds two item, target url and pingback server url
//var LocalStrings = document.getElementById("bundle_MozBlog");
//Bundle Strins for MozBlog Localisation - Added by P.L. 01-01-03

function clearField()
{
  editorHandle.content = "";
  editorHandle.clearMeta();
}

function getPageSelection()
{
  var text = window._content.getSelection();
  if (window._content.frames.length > 0)
    return null;
  else if (text == "")
    return null;
  else
    return text;
}

function blogThisPage()
{
  if (document.getElementById('bottomBar').collapsed) hideDoc();
  var selectedText = getPageSelection();
  if (selectedText) {
    window.setTimeout("insertSelection()", 300);
  } else {
    window.setTimeout("insertPage()", 300);
  }
}

function insertSelection()
{
  var selectedText = getPageSelection();
  var LocalStrings = document.getElementById("bundle_MozBlog");
  var newPostContent = selectedText + "<br>" + LocalStrings.getString("MozBlog.From")
                                    + " <a href='" + window._content.location + "'>"
                                    + window._content.document.title + "</a>]";
  createNewPost();
  editorHandle.content = newPostContent;
}

function insertPage()
{
  var newPostContent =" [<a href='"+ window._content.location+ "'>" + window._content.document.title + "</a>]";
  if (window._content.location != "about:blank") {
    createNewPost();
    editorHandle.content = newPostContent;
  }
}

function cleanSource(plainContent)
{
  var tempContent = plainContent;
  var regex = /^<.+<body>/gi;
  tempContent = tempContent.replace(regex, "");
  regex = /<\/body><\/html>/gi;
  tempContent = tempContent.replace(regex, "");
  var stripBreaks;
  try {
	stripBreaks = discussPref.getBoolPref("discuss.removeBreaks");
  } catch (e) {
	stripBreaks = false;
  }
  if (stripBreaks) {
	regex = /<br>/gi;
	tempContent = tempContent.replace(regex, "");
  }
  if (tempContent.charAt(tempContent.length-1) != '\n') {
	tempContent = tempContent + "\n";
  }
  return tempContent;
}
// Already in mozblogCommand.js | Mike Check this!

function showHideFormatBar()
{
  var discussFormatBar = document.getElementById("discussFormatBar");
  //var LocalStrings = document.getElementById("bundle_MozBlog");
  if (discussFormatBar.collapsed == true) {
    discussFormatBar.collapsed = false;
    discussFormatbarOpen = true;
    document.getElementById("discuss-open-formatbar")
      .setAttribute("label",document.getElementById("bundle_MozBlog").getString("MozBlog.HideFormatToolbar")); 
  } else {
    discussFormatBar.collapsed = true;
    discussFormatbarOpen = false;
    document.getElementById("discuss-open-formatbar")
      .setAttribute("label",document.getElementById("bundle_MozBlog").getString("MozBlog.ShowFormatToolbar"));
  }
}

function setParagraph(format)
{
  editorHandle._getCurrentEditor().setParagraphFormat(format);
}

function SetDocumentEditable(isDocEditable)
{
  var editor = editorHandle._getCurrentEditor();
  const nsIPlaintextEditor = Components.interfaces.nsIPlaintextEditor;
  if (editor && editor.document)
  {
    try {
      var body = editor.document.getElementsByTagName("body")[0];
      //bgcolor="#FFCCCC"
      if (!isDocEditable) {
        editor.flags |= nsIPlaintextEditor.eEditorReadonlyMask;
        editor.setAttribute(body,"bgcolor","CCCCCC");  //"#C0C0C0"
        document.getElementById("sourceEditor").readonly = true;  //scraptDocument | May have been introduce by error by P. Lacourse | Mike Check this!
        document.getElementById("editPost").disabled = false;
        document.getElementById("publish").disabled = true;  //Added to prevent some JScript error since trying to publish a non editable post Make the blogID null.
        document.getElementById("discussFormatBar").disabled = true;
        document.getElementById("doctitle").disabled = true;
        document.getElementById("docDescription").disabled = true;
        document.getElementById("categoryBox").disabled = true;
        document.getElementById("newCategoryValue").disabled = true;
        document.getElementById("spellButton").disabled = true;
        document.getElementById("discussFormatBar").disabled = true;
      } else {
        editor.flags &= ~nsIPlaintextEditor.eEditorReadonlyMask;
        editor.setAttribute(body,"bgcolor","#FFFFFF");
        document.getElementById("sourceEditor").readonly = false;
        document.getElementById("editPost").disabled = true;
        document.getElementById("publish").disabled = false;  //Added to prevent some JScript error since trying to publish a non editable post Make the blogID null.
        document.getElementById("discussFormatBar").disabled = false;
        document.getElementById("doctitle").disabled = false;
        document.getElementById("docDescription").disabled = false;
        document.getElementById("categoryBox").disabled = false;
        document.getElementById("newCategoryValue").disabled = false;
        document.getElementById("spellButton").disabled = false;
        document.getElementById("discussFormatBar").disabled = false;
      }
    } catch(e) { dump("SetDocumentEditable: "+e) }
    // update all commands
    // window.updateCommands("create");
  }
}


function preFetchWebsite(remoteUrl)
{
  editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Analysing") + remoteUrl + " ... ", null);
  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                            .getService(Components.interfaces.nsIIOService);
  var url = Components.classes["@mozilla.org/network/standard-url;1"];
  var websiteUrl = url.createInstance(Components.interfaces.nsIURL);
  websiteUrl.spec = remoteUrl;
  var httpChannel = ioService.newChannelFromURI(websiteUrl)
                             .QueryInterface(Components.interfaces.nsIHttpChannel);
  httpChannel.asyncOpen(httpListener, null);
}

var httpListener = {
  pingbackUrl : "",
  onStartRequest: function(request, ctxt) {
    dump("onStartRequest status = " + request.status + "\n");
  },
  onStopRequest: function(request, ctxt, status, errorMsg) {
    var LocalStrings = document.getElementById("bundle_MozBlog");
    try {
      var httpChannel = request.QueryInterface(Components.interfaces.nsIHttpChannel);
      var result = httpChannel.getResponseHeader("X-Pingback");
      if (result)
        this.pingbackUrl = result;
      pingbackItem[1] = this.pingbackUrl;
      pingbackUrlList.appendItem(pingbackItem);
      editorHandle.currentStatus(LocalStrings.getString("MozBlog.FoundPingbackUrl") + this.pingbackUrl + "\n", 100);
    } catch (e) {
      editorHandle.currentStatus(LocalStrings.getString("MozBlog.NoPingbackDetails"), 100);
    }
  },
  onDataAvailable: function(request, ctxt, inStream, sourceOffset, count) {
    this.cool = "cool";
    if (count > 500) {
      request.cancel(2);
      var regex = /<link rel="pingback" href="([^"]+)" ?\/?>/gi;
      var scriptableInputStream = Components.classes["@mozilla.org/scriptableinputstream;1"]
                                            .createInstance(Components.interfaces.nsIScriptableInputStream);
      scriptableInputStream.init(inStream);
      var matchArray = regex.exec(scriptableInputStream.read(-1));
      this.pingbackUrl = RegExp.$1;
      scriptableInputStream.close();
    }
    dump("onDataAvailable status = " + request.status + " " + count + "\n");
  }
}

var blogEditorObserver = {
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("text/html");
    return flavours;
  },
  onDragOver: function (evt,flavour,session) {
    selectionHandle = editorHandle.editorShell.editorSelection
                                  .QueryInterface(Components.interfaces.nsISelection);
    var selectedText = selectionHandle.toString();
    var LocalStrings = document.getElementById("bundle_MozBlog");
    if (selectedText) {
      document.getElementById("discussEditorType").setAttribute("selectedIndex", 2);
      document.getElementById("dragDropBox").setAttribute("value",
                              LocalStrings.getString("MozBlog.ReplacingLinkWith") + " " + selectedText);
    }
  },
  onDrop: function (evt,dropdata,session) {
    selectionHandle = editorHandle.editorShell.editorSelection
                                  .QueryInterface(Components.interfaces.nsISelection);
    document.getElementById("discussEditorType").setAttribute("selectedIndex", 0);
    var selectedText = new String(selectionHandle.toString());

    if (selectedText) {
      var extractUrl = new RegExp("href=[\"']?([^\"']+)", "gi");
      var result = extractUrl.exec(dropdata.data);
      preFetchWebsite(RegExp.$1);
      pingbackItem[0] = RegExp.$1;
      // need to implement checking valid <a>
      var urlString = new String(dropdata.data);
      if (selectedText.charAt(selectedText.length - 1) == " ") {
        var tmpSelectedText = selectedText.slice(0, - 1);
        newString = urlString.replace(/>.+<\/a>/i, ">" + tmpSelectedText + "</a>&nbsp;");
        var regex = new RegExp('"' + window._content.location + '"', "gi");
        if (regex.test(newString)) {
          newString = newString.replace(/<a\s/i, "<a title='" +
                      window._content.document.title + "' ");
        }
      } else {
        newString = urlString.replace(/>.+<\/a>/i, ">" + selectedText + "</a>");
      }
      editorHandle.editorShell.InsertSource(newString);
      document.getElementById("edit-frame").focus();
    } else {
      alert ('block');
    }
  }
};