/* ***** BEGIN LICENSE BLOCK *****
 * Version: NPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Netscape Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mike Lee's code.
 *
 * The Initial Developer of the Original Code is
 * Mike Lee.
 * Portions created by the Initial Developer are Copyright (C) 2002
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *	Mike Lee <tseng_mike@yahoo.com>
 *  Cedric Shock <cedricshock@ou.edu>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the NPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the NPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
/*
 *  myBlog
 *  Version: $Revision: 1.15 $
 *
 *  $Id: myBlog.js,v 1.15 2003/07/21 03:27:06 paullacourse Exp $
 */

var fileModified   = false;
var falseSelection = false;

/* function in this file:
    function loadPreviousPost(selectedResource)
    function saveLastPost()
    function getblogContent()
    function getAccountType()
    function updateSelection()
*/

function loadPreviousPost(selectedResource)
{
  if (falseSelection == false) {
    saveLastPost();
    getblogContent();
    var published = "N";
    if (selectedResource) {
      var ds    = rdfStore.getSource("blogHistory");
      published = getRDFAttribute(ds, selectedResource, "http://www.exitspace.net/blog/published");
    }
    if (published != "N") { // if it's already published
      SetDocumentEditable(false);
    } else {
      SetDocumentEditable(true);
      postStore.snapState();
    }
  } else {
    falseSelection = false;
  }
}

function saveLastPost()
{
  postStore.content = editorHandle.content;
  //alert(fileModified+":"+editorHandle.content+":"+globalState.filename);
  if (fileModified == true) {
    try {
      postStore.saveToDisk();
      fileModified = false;
    } catch (e) { dump("myBlog::saveLastPost() saveToDisk failed:\n" +e+"\n\n"); }
  }
}

function getblogContent()
{
  getlocalContent();
  var ds                  = rdfStore.getSource("blogHistory");
  var selectedResource    = postListBox.selectedResource;
/*<<<<<<< myBlog.js
  globalState.title       = getRDFAttribute(ds, selectedResource, "http://purl.org/rss/1.0/title");
  globalState.description = getRDFAttribute(ds, selectedResource, "http://purl.org/rss/1.0/description");
}

function getRecentBlog()
{
  var blogNS             = "http://www.exitspace.net/blog/";
  var BlogSrvNS          = RDF.GetResource("http://www.exitspace.net/blog/blogServer");
  var ds                 = rdfStore.getSource("profile");
  var blogIDNS           = RDF.GetResource(globalState.blogID);
  var BlogSrvContainerNS = ds.GetTarget(blogIDNS, BlogSrvNS, true)
                             .QueryInterface(Components.interfaces.nsIRDFResource);
  var retrievePost       = parseInt(getRDFAttribute(ds, BlogSrvContainerNS, blogNS+"retrieveNum"));
  ds = null;
  if (!retrievePost)
    retrievePost = 5;
  if (getAccountType() == "movabletype") {
    metaWeblogGetRecentPosts(retrievePost);
  } else if (getAccountType() == "radio") {
    metaWeblogGetRecentPosts(retrievePost);
  } else {
    getRecentPosts(retrievePost);
  }
}

function deleteblogPost()
{
  var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
  if (globalState.blogID == "http://localhost/") {
    var filename = globalState.filename;

    if (confirm(MozBlogLocalStr.getString("MozBlog.SureToDeletePost") + filename)) {
      postListBox.deleteSelection();
    }
  } else if (globalState.postID == -1) {
    if (confirm(MozBlogLocalStr.getString("MozBlog.SureToDeletePost"))) {
      postListBox.deleteSelection();
    }
=======*/
  //dump("gooooooooooooooooooooooooo\n\n");
  if (selectedResource) {
    var blogTitle           = document.getElementById("doctitle").value;
    blogTitle               = getRDFAttribute(ds, selectedResource, "http://purl.org/rss/1.0/title");
    var blogDescription     = document.getElementById("docDescription").value;
    blogDescription         = getRDFAttribute(ds, selectedResource, "http://purl.org/rss/1.0/description");
//>>>>>>> 1.10
  } else {
/*<<<<<<< myBlog.js
    var postid = globalState.postID;
    if (confirm(MozBlogLocalStr.getString("MozBlog.SureToDeletePost"))) {
      deletePost(postid);
    }
  }
=======*/
    //dump("fooooooooooooooooooooooooo\n\n");
  }
//>>>>>>> 1.10
}

function getAccountType()
{
  var exitspaceNS  = "http://www.exitspace.net/blog/";
  var ds           = rdfStore.getSource("profile");
  var RDF          = Components.classes['@mozilla.org/rdf/rdf-service;1']
                               .getService(Components.interfaces.nsIRDFService);
  var postHandle   = RDF.GetResource(document.getElementById("blogIDs").selectedItem.value);
  var blogServer   = ds.GetTarget(postHandle, RDF.GetResource(exitspaceNS + "blogServer"), true);
  blogServer       = blogServer.QueryInterface(Components.interfaces.nsIRDFResource);
  var blogType     = getRDFAttribute(ds, blogServer, exitspaceNS + "blogType");
  return blogType;
}

function updateSelection()
{
  SetDocumentEditable(false);
}