/***************************************************************************************
 * Pingback implementation
 **************************************************************************************/

var pingbackUrlList = new biEnumerator();
var pingbackItem = new Array(2); // it holds two item, target url and pingback server url

function testXML()
{
  //httpRequest.onload = XMLlistener;
  //httpRequest.overrideMimeType("text/xml");
  //p.open("GET", "http://ln.hixie.ch/");
  //httpRequest.open("GET", "http://dummy-blog.org/");
  //httpRequest.send(null);
  preFetchWebsite("http://dummy-blog.org/");
  //preFetchWebsite("http://pox.pwp.blueyonder.co.uk/video/bf1942_weenie.wmv");
}

function preFetchWebsite(remoteUrl)
{
  editorHandle.currentStatus("Analysing " + remoteUrl + " ... ", null);
  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                            .getService(Components.interfaces.nsIIOService);
  var url = Components.classes["@mozilla.org/network/standard-url;1"];
  var websiteUrl = url.createInstance(Components.interfaces.nsIURL);
  websiteUrl.spec = remoteUrl;
  var httpChannel = ioService.newChannelFromURI(websiteUrl)
                             .QueryInterface(Components.interfaces.nsIHttpChannel);
  httpChannel.asyncOpen(httpListener, null);
}

var httpListener = {
  pingbackUrl : "",
  onStartRequest: function(request, ctxt) {
    dump("onStartRequest status = " + request.status + "\n");
  },
  onStopRequest: function(request, ctxt, status, errorMsg) {
    try {
      var httpChannel = request.QueryInterface(Components.interfaces.nsIHttpChannel);
      var result = httpChannel.getResponseHeader("X-Pingback");
      if (result)
        this.pingbackUrl = result;
      pingbackItem[1] = this.pingbackUrl;
      pingbackUrlList.appendItem(pingbackItem);
      editorHandle.currentStatus("found pingback url: " + this.pingbackUrl + "\n", 100);
    } catch (e) {
      editorHandle.currentStatus("No pingback details found\n", 100);
    }
  },
  onDataAvailable: function(request, ctxt, inStream, sourceOffset, count) {
    this.cool = "cool";
    if (count > 500) {
      request.cancel(2);
      var regex = /<link rel="pingback" href="([^"]+)" ?\/?>/gi;
      var scriptableInputStream = Components.classes["@mozilla.org/scriptableinputstream;1"]
                                            .createInstance(Components.interfaces.nsIScriptableInputStream);
      scriptableInputStream.init(inStream);
      var matchArray = regex.exec(scriptableInputStream.read(-1));
      this.pingbackUrl = RegExp.$1;
      scriptableInputStream.close();
    }
    dump("onDataAvailable status = " + request.status + " " + count + "\n");
  }
}

function pingbackBlog(sourceUrl)
{
  while(!pingbackUrlList.isDone()) {
    var items = pingbackUrlList.next();
    pingbackPing(items[1], sourceUrl, items[0]);
  }
  pingbackUrlList.init();
}

function pingbackPing(serverUrl, source, target)
{
  editorHandle.currentStatus("Pinging: " + serverUrl + "...");
  var sourceURI = xmlRpc.createType(xmlRpc.STRING, {});
  sourceURI.data = source;
  var targetURI = xmlRpc.createType(xmlRpc.STRING, {});
  targetURI.data = target;
  xmlRpc.init(serverUrl);
  xmlRpc.asyncCall(pingbackPingListener, null, "pingback.ping",
                   [sourceURI, targetURI], 2);
}

var pingbackPingListener = {
  onResult: function(client, ctxt, result) {
    var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
    result = result.QueryInterface(Components.interfaces.nsISupportsPrimitive);
    if (result.type == 3 || result.type == 2) {
      try {
        var pingStatus = result.QueryInterface(Components.interfaces.nsISupportsString);
      } catch (e) {
        var pingStatus = result.QueryInterface(Components.interfaces.nsISupportsCString);
      }
      editorHandle.currentStatus(MozBlogLocalStr.getString("MozBlog.DoneWithMsg") + pingStatus.data, 100);  //"done, with message: "
    } else {
      editorHandle.currentStatus(MozBlogLocalStr.getString("MozBlog.PingUnsuccessful"), 100);  //"Ping unsuccessful"
    }
  }, onFault: function(client, ctxt, fault) {
    editorHandle.currentStatus(MozBlogLocalStr.getString("MozBlog.Fault") + fault + "\n", 100);
  }, onError: function(client, ctxt, status, errorMsg) {
    editorHandle.currentStatus(MozBlogLocalStr.getString("MozBlog.Error") + status.toString(16) + ") " + errorMsg + "\n", 100);
  }
};

/***************************************************************************************
 * Ping weblogs.com
 **************************************************************************************/
function pingWeblogCom()
{
  var ds           = rdfStore.getSource("profile");
  var blogIDNS     = RDF.GetResource(document.getElementById("blogIDs").selectedItem.value);
  var blogName     = getRDFAttribute(ds, blogIDNS, "http://www.exitspace.net/blog/siteName");
  var blogUrl 	   = blogIDNS.Value;
  weblogUpdatesPing(blogName, blogUrl);
  ds = null;
}

/**
 * weblogUpdates.ping
 * return dictionary of success and message
 */
function weblogUpdatesPing(blogName, blogUrl)
{
  try {
    pingBlog = discussPref.getBoolPref("blogger.pingBlog");
  } catch (e) {
    pingBlog = false;
  }
  if (pingBlog == true) {
    var userlandServerurl = xmlRpc.createType(xmlRpc.STRING, {});
    userlandServerurl = "http://rpc.weblogs.com/RPC2";
    var siteName = xmlRpc.createType(xmlRpc.STRING, {});
    siteName.data = blogName;
    var siteUrl = xmlRpc.createType(xmlRpc.STRING, {});
    siteUrl.data = blogUrl;
    xmlRpc.init(userlandServerurl);
    xmlRpc.asyncCall(ULpingListener, null, "weblogUpdates.ping", [siteName, siteUrl], 2);
  }
}

var ULpingListener = {
  onResult: function(client, ctxt, result) {
    dictResult = result.QueryInterface(Components.interfaces.nsIDictionary);
    dictResult1 = dictResult.getValue("flerror");
    dictResult2 = dictResult.getValue("message");
    dictResult1 = dictResult1.QueryInterface(Components.interfaces.nsISupportsPRBool);
    try {
      dictResult2 = dictResult2.QueryInterface(Components.interfaces.nsISupportsString);
    } catch (e) {
      dictResult2 = dictResult2.QueryInterface(Components.interfaces.nsISupportsCString);
    }
    var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
    editorHandle.currentStatus(MozBlogLocalStr.getString("MozBlog.Weblog.comPing") + dictResult2 + "\n", 100);
  }, onFault: function(client, ctxt, fault) {
    dump("Fault! " + fault + "\n");
  }, onError: function(client, ctxt, status, errorMsg) {
    dump("Error! (" + status.toString(16) + ") " + errorMsg + "\n", 100);
  }
};
